
/*
Morning with kids known as a very stressful and busy time. Between getting yourself ready you need to help them to get ready,make them food,do some house chores and still be able to leave the house on time.
So we decided to create this project to make the morning more easy and fun.

We create 5 features to help you get ready in the morning:

1.Upgraded alarm clock-
If you didnt shut down your alarm and the lights are still off it will keep ringing until you turn on the light.
If after 15 minutes you still didnt turn it off, the app will send a message to a person that you choose that you didnt wake up and ask for him to call you.

2.Help to get dress in the morning-
The app is conect to real time weater and when you want to pick up an outfit it will tell you the temperature and recond which clothe to wear acording to the weater.
In addition to make the kids want to get dress in the morning there is an option for them to pick color that they want to wear and on the CPX they will see 2 colors that can match the color thay choose. This will help out the parents by not need to chose clothes for them.

3.Relaxing music-
If there is a lous baby cry noise the CPX will start to play him music.

4.Meeting-
recicve a notifiction with all meeting of the day. In addition if you have in your calander a late meeting it will autumaticly send a notification to your partner that you will come home late today.

5.Reminders-
befor you leave the house there will be a new reminder in your phone with things you need to make sure you did befor leaving the house.
*/

#define BLYNK_PRINT SerialUSB
#define BLYNK_DEBUG SerialUSB

#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
#include <Adafruit_CircuitPlayground.h>
#include <Time.h>
#include <TimeLib.h>



char auth[] = "9G8M5BTMXCrtfJuw8VWefHuvDPg7anf6";
char ssid[] = "latin";
char pass[] = "0528388197";

#define EspSerial Serial1
#define ESP8266_BAUD 115200

ESP8266 wifi(&EspSerial);


int pinValueV2,pinValueV3;
float r = 0,g = 0,b = 0,noise;
float lowTemp = 16,midTemp = 22,highTemp = 26;
float light;
int hourAlarm,minAlarm,secAlarm;
boolean send = false , sendMsg = false , wakeUp = false;
int Y;
double tempLevel;

void setup() 
{
  CircuitPlayground.begin();
  SerialUSB.begin(9600);
  EspSerial.begin(ESP8266_BAUD);
  Blynk.begin(auth, wifi, ssid, pass);

  //Set the current time
  setTime(7, 59, 50, 27, 8, 2021);
}

void loop() 
{
  //Alarm
  light=CircuitPlayground.lightSensor();
  sleep();
  //Relaxing Music  
  noise = CircuitPlayground.soundSensor();
  relex(noise);
  //Reminder
  reminder(8,30,0);
  //Meeting
  Y = CircuitPlayground.motionY();
  Blynk.run();
}

//Send notification of all meeting of the day , and send a notification to the partenr if you have a late meeting.
void meeting()
{
  Serial.println(Y);
  if(Y < -1 && sendMsg == false)
  {
    sendMsg = true;
    Blynk.virtualWrite(V6, 1);
  }
}

//Add to the phone reminders things you need to do before you leave the house in the morning.
void reminder(int reminderHour ,int reminderMin , int reminderSec)
{
    hourAlarm = hour();
    minAlarm = minute();
    secAlarm = second();
    if(hourAlarm == reminderHour && minAlarm == reminderMin && secAlarm == reminderSec)
    {
      String s = "Don't forget to:\n1.put the lunch box in the kids bag\n2.Take a coat or a jacket\n3.Shut down all electronic at the house";
      Blynk.virtualWrite(V15, s);
    }  
}

//Start alarm clock at 8am
BLYNK_WRITE(V3)
{
   pinValueV3 = param.asInt();
   while(pinValueV3 == 1 && wakeUp == false)
   {  
    hourAlarm = hour();
    minAlarm = minute();
    secAlarm = second();
    if(hourAlarm == 8 && minAlarm == 0 && secAlarm == 0)
    {
       for(int i=0;i<5;i++)
        {
        CircuitPlayground.playTone(530, 200);
        delay(50);
        wakeUp = true;
        }
       break;
    }
    pinValueV3 = param.asInt();
   }
}

//If you didn't shut down the alarm clock and there is still dark in the room the alarm will keep going.
//also after 15 min you didnt wake up send a message to someone else to wake you up.
void sleep()
{
  minAlarm = minute();
  secAlarm = second();
  if(pinValueV3 == 1 && light < 100)
  {
    CircuitPlayground.playTone(530, 200);
    if(minAlarm > 15 && send == false)
    {
      send = true;
      Blynk.virtualWrite(V5, 1);
    }
  }
}

//If there is loud noise plays music to relax
void relex(float noise)
{
  if(noise > 50)
  {
    CircuitPlayground.playTone(262, 200);
    CircuitPlayground.playTone(262, 200);
    CircuitPlayground.playTone(400, 200);
    CircuitPlayground.playTone(400, 200);
    CircuitPlayground.playTone(440, 200);
    CircuitPlayground.playTone(440, 200);
    CircuitPlayground.playTone(400, 200);
    delay(200);
    CircuitPlayground.playTone(350, 200);
    CircuitPlayground.playTone(350, 200);
    CircuitPlayground.playTone(330, 200);
    CircuitPlayground.playTone(330, 200);
    CircuitPlayground.playTone(294, 200);
    CircuitPlayground.playTone(294, 200);
    CircuitPlayground.playTone(262, 200);
    delay(200);
    CircuitPlayground.playTone(400, 200);
    CircuitPlayground.playTone(400, 200);
    CircuitPlayground.playTone(350, 200);
    CircuitPlayground.playTone(350, 200);
    CircuitPlayground.playTone(330, 200);
    CircuitPlayground.playTone(330, 200);
    CircuitPlayground.playTone(294, 200);  
    delay(200);
    CircuitPlayground.playTone(400, 200);
    CircuitPlayground.playTone(400, 200);
    CircuitPlayground.playTone(350, 200);
    CircuitPlayground.playTone(350, 200);
    CircuitPlayground.playTone(330, 200);
    CircuitPlayground.playTone(330, 200);
    CircuitPlayground.playTone(294, 200);
  }
}

BLYNK_WRITE(V0)
{  
 //V0 is connected to a weather website.
 tempLevel = param.asDouble();
} 
  
//Send message which outfit you should wear according to the weather.
BLYNK_WRITE(V2)
{
  pinValueV2 = param.asInt(); 
  String msg;
  if(tempLevel > highTemp)
  {
    msg = "Good Morning,\ntoday is a very hot day wear something short.";
  }
  if(tempLevel < highTemp && tempLevel > lowTemp)
  {
    msg = "Good Morning ,\ntoday the weather is nice , wear something short and take a jacket in your bag.";
  }
  if(tempLevel < lowTemp)
  {
    msg = "Good Morning ,\ntoday it's cold , wear something warm.";
  }
  Blynk.virtualWrite(V7,tempLevel);
  Blynk.notify(msg);
}

//Help choose colors to outfit
BLYNK_WRITE(V1)
{ 
  if(pinValueV2 == 1)
  {
    r = param[0].asInt();
    g = param[1].asInt();
    b = param[2].asInt();
    for (int i = 0; i < 5; ++i) 
    {
    CircuitPlayground.setPixelColor(i,g,r,b);
    delay(100);
    }
    for (int i = 6; i < 10; ++i) 
    {
    CircuitPlayground.setPixelColor(i, b,g,r);
    delay(100);
    }
  }
  else
  {
    for (int i = 0; i < 10; ++i) 
    {
    CircuitPlayground.setPixelColor(i, 0,0,0);
    }
  }
}
